from typing import Dict, FrozenSet, List


# All aliases, extensions and prefixes here have been reproduced
# from article quality model source code, by courtesy of Isaac Johnson.
# See: https://gitlab.wikimedia.org/repos/research/article-quality/-/blob/43d1cea6b2a0a49361d19fe12e2a49228708cfa2/article_quality/quality_model.py#L8-L526  # noqa: E501
VIDEO_EXTENSIONS: List[str] = ["ogv", "webm", "mpg", "mpeg"]
AUDIO_EXTENSIONS: List[str] = ["ogg", "mp3", "mid", "webm", "flac", "wav", "oga"]
IMAGE_EXTENSIONS: List[str] = [
    "jpg",
    "png",
    "svg",
    "gif",
    "jpeg",
    "tif",
    "bmp",
    "webp",
    "xcf",
]
MEDIA_EXTENSIONS: FrozenSet[str] = frozenset(
    IMAGE_EXTENSIONS + VIDEO_EXTENSIONS + AUDIO_EXTENSIONS
)

CATEGORY_PREFIXES: List[str] = ["Category"]
CATEGORY_ALIASES: Dict[str, List[str]] = {
    "ab": ["Категория", "Акатегориа"],
    "ace": ["Kawan", "Kategori"],
    "af": ["Kategorie"],
    "ak": ["Nkyekyem"],
    "als": ["Kategorie"],
    "am": ["መደብ"],
    "an": ["Categoría"],
    "ang": ["Flocc"],
    "ar": ["تصنيف"],
    "arc": ["ܣܕܪܐ"],
    "arz": ["تصنيف"],
    "as": ["CAT", "শ্ৰেণী", "श्रेणी", "শ্রেণী"],
    "ast": ["Categoría"],
    "atj": ["Tipanictawin"],
    "av": ["Категория"],
    "ay": ["Categoría"],
    "az": ["Kateqoriya"],
    "azb": ["بؤلمه"],
    "ba": ["Төркөм", "Категория"],
    "bar": ["Kategorie"],
    "bat-smg": ["Kategorija", "Kateguorėjė"],
    "bcl": ["Kategorya"],
    "be": ["Катэгорыя"],
    "be-x-old": ["Катэгорыя"],
    "bg": ["Категория"],
    "bh": ["श्रेणी"],
    "bjn": ["Tumbung", "Kategori"],
    "bm": ["Catégorie"],
    "bn": ["বিষয়শ্রেণী", "വിഭാഗം"],
    "bpy": ["থাক"],
    "br": ["Rummad"],
    "bs": ["Kategorija"],
    "bug": ["Kategori"],
    "bxr": ["Категори", "Категория"],
    "ca": ["Categoria"],
    "cbk-zam": ["Categoría"],
    "cdo": ["分類"],
    "ce": ["Категори", "Тоба", "Кадегар"],
    "ceb": ["Kategoriya"],
    "ch": ["Katigoria"],
    "ckb": ["پ", "پۆل"],
    "co": ["Categoria"],
    "crh": ["Категория", "Kategoriya"],
    "cs": ["Kategorie"],
    "csb": ["Kategòrëjô"],
    "cu": ["Катигорї", "Категория", "Катигорїꙗ"],
    "cv": ["Категори"],
    "cy": ["Categori"],
    "da": ["Kategori"],
    "de": ["Kategorie"],
    "din": ["Bekätakthook"],
    "diq": ["Kategoriye", "Kategori"],
    "dsb": ["Kategorija"],
    "dty": ["श्रेणी"],
    "dv": ["ޤިސްމު"],
    "el": ["Κατηγορία"],
    "eml": ["Categoria"],
    "eo": ["Kategorio"],
    "es": ["CAT", "Categoría"],
    "et": ["Kategooria"],
    "eu": ["Kategoria"],
    "ext": ["Categoría", "Categoria"],
    "fa": ["رده"],
    "ff": ["Catégorie"],
    "fi": ["Luokka"],
    "fiu-vro": ["Katõgooria"],
    "fo": ["Bólkur"],
    "fr": ["Catégorie"],
    "frp": ["Catègorie"],
    "frr": ["Kategorie"],
    "fur": ["Categorie"],
    "fy": ["Kategory"],
    "ga": ["Rang", "Catagóir"],
    "gag": ["Kategori", "Kategoriya"],
    "gan": ["分類", "分类"],
    "gd": ["Roinn-seòrsa"],
    "gl": ["Categoría"],
    "glk": ["جرگه", "رده"],
    "gn": ["Ñemohenda"],
    "gom": ["वर्ग", "श्रेणी"],
    "gor": ["Dalala"],
    "got": ["𐌷𐌰𐌽𐍃𐌰"],
    "gu": ["શ્રેણી", "CAT", "શ્રે"],
    "gv": ["Ronney"],
    "hak": ["分類"],
    "haw": ["Māhele"],
    "he": ["קטגוריה", "קט"],
    "hi": ["श्र", "श्रेणी"],
    "hif": ["vibhag"],
    "hr": ["CT", "KT", "Kategorija"],
    "hsb": ["Kategorija"],
    "ht": ["Kategori"],
    "hu": ["Kategória"],
    "hy": ["Կատեգորիա"],
    "ia": ["Categoria"],
    "id": ["Kategori"],
    "ie": ["Categorie"],
    "ig": ["Ébéonọr", "Òtù"],
    "ii": ["分类"],
    "ilo": ["Kategoria"],
    "inh": ["ОагӀат"],
    "io": ["Kategorio"],
    "is": ["Flokkur"],
    "it": ["CAT", "Categoria"],
    "ja": ["カテゴリ"],
    "jbo": ["klesi"],
    "jv": ["Kategori"],
    "ka": ["კატეგორია"],
    "kaa": ["Sanat", "Kategoriya", "Санат", "سانات"],
    "kab": ["Taggayt"],
    "kbd": ["Категория", "Категориэ"],
    "kbp": ["Catégorie"],
    "kg": ["Kalasi"],
    "kk": ["Sanat", "Санат", "سانات"],
    "kl": ["Sumut_atassuseq", "Kategori", "Sumut atassuseq"],
    "km": ["ចំនាត់ថ្នាក់ក្រុម", "ចំណាត់ក្រុម", "ចំណាត់ថ្នាក់ក្រុម"],
    "kn": ["ವರ್ಗ"],
    "ko": ["분류"],
    "koi": ["Категория"],
    "krc": ["Категория"],
    "ks": ["زٲژ"],
    "ksh": [
        "Saachjropp",
        "Saachjrop",
        "Katejori",
        "Kategorie",
        "Saachjrupp",
        "Kattejori",
        "Sachjrop",
    ],
    "ku": ["Kategorî", "پۆل"],
    "kv": ["Категория"],
    "kw": ["Class", "Klass"],
    "ky": ["Категория"],
    "la": ["Categoria"],
    "lad": ["Kateggoría", "Katēggoría", "Categoría"],
    "lb": ["Kategorie"],
    "lbe": ["Категория"],
    "lez": ["Категория"],
    "lfn": ["Categoria"],
    "li": ["Categorie", "Kategorie"],
    "lij": ["Categorîa", "Categoria"],
    "lmo": ["Categuria", "Categoria"],
    "ln": ["Catégorie"],
    "lo": ["ໝວດ"],
    "lrc": ["دأسە"],
    "lt": ["Kategorija"],
    "ltg": ["Kategoreja"],
    "lv": ["Kategorija"],
    "mai": ["CA", "श्रेणी"],
    "map-bms": ["Kategori"],
    "mdf": ["Категорие", "Категория"],
    "mg": ["Sokajy", "Catégorie"],
    "mhr": ["Категория", "Категорий"],
    "min": ["Kategori"],
    "mk": ["Категорија"],
    "ml": ["വിഭാഗം", "വി", "വർഗ്ഗം", "വ"],
    "mn": ["Ангилал"],
    "mr": ["वर्ग"],
    "mrj": ["Категори", "Категория"],
    "ms": ["Kategori"],
    "mt": ["Kategorija"],
    "mwl": ["Catadorie", "Categoria"],
    "my": ["ကဏ္ဍ"],
    "myv": ["Категория"],
    "mzn": ["رج", "رده"],
    "nah": ["Neneuhcāyōtl", "Categoría"],
    "nap": ["Categurìa", "Categoria"],
    "nds": ["Kategorie"],
    "nds-nl": ["Categorie", "Kattegerie", "Kategorie"],
    "ne": ["श्रेणी"],
    "new": ["पुचः"],
    "nl": ["Categorie"],
    "nn": ["Kategori"],
    "no": ["Kategori"],
    "nrm": ["Catégorie"],
    "nso": ["Setensele"],
    "nv": ["Tʼááłáhági_átʼéego", "Tʼááłáhági átʼéego"],
    "oc": ["Categoria"],
    "olo": ["Kategourii"],
    "or": ["ବିଭାଗ", "ଶ୍ରେଣୀ"],
    "os": ["Категори"],
    "pa": ["ਸ਼੍ਰੇਣੀ"],
    "pcd": ["Catégorie"],
    "pdc": ["Abdeeling", "Kategorie"],
    "pfl": ["Kadegorie", "Sachgrubb", "Kategorie"],
    "pi": ["विभाग"],
    "pl": ["Kategoria"],
    "pms": ["Categorìa"],
    "pnb": ["گٹھ"],
    "pnt": ["Κατηγορίαν"],
    "ps": ["وېشنيزه"],
    "pt": ["Categoria"],
    "qu": ["Katiguriya"],
    "rm": ["Categoria"],
    "rmy": ["Shopni"],
    "ro": ["Categorie"],
    "roa-rup": ["Categorie"],
    "roa-tara": ["Categoria"],
    "ru": ["Категория", "К"],
    "rue": ["Категория", "Катеґорія"],
    "rw": ["Ikiciro"],
    "sa": ["वर्गः"],
    "sah": ["Категория"],
    "sat": ["ᱛᱷᱚᱠ"],
    "sc": ["Categoria"],
    "scn": ["Catigurìa"],
    "sd": ["زمرو"],
    "se": ["Kategoriija"],
    "sg": ["Catégorie"],
    "sh": ["Kategorija", "Категорија"],
    "si": ["ප්‍රවර්ගය"],
    "sk": ["Kategória"],
    "sl": ["Kategorija"],
    "sq": ["Kategoria", "Kategori"],
    "sr": ["Kategorija", "Категорија"],
    "srn": ["Categorie", "Guru"],
    "stq": ["Kategorie"],
    "su": ["Kategori"],
    "sv": ["Kategori"],
    "sw": ["Jamii"],
    "szl": ["Kategoryjo", "Kategoria"],
    "ta": ["பகுப்பு"],
    "tcy": ["ವರ್ಗೊ"],
    "te": ["వర్గం"],
    "tet": ["Kategoría", "Kategoria"],
    "tg": ["Гурӯҳ"],
    "th": ["หมวดหมู่"],
    "ti": ["መደብ"],
    "tk": ["Kategoriýa"],
    "tl": ["Kategorya", "Kaurian"],
    "tpi": ["Grup"],
    "tr": ["Kategori", "KAT"],
    "tt": ["Төркем", "Törkem", "Категория"],
    "ty": ["Catégorie"],
    "tyv": ["Аңгылал", "Категория"],
    "udm": ["Категория"],
    "ug": ["تۈر"],
    "uk": ["Категория", "Категорія"],
    "ur": ["زمرہ"],
    "uz": ["Turkum", "Kategoriya"],
    "vec": ["Categoria"],
    "vep": ["Kategorii"],
    "vi": ["Thể_loại", "Thể loại"],
    "vls": ["Categorie"],
    "vo": ["Klad"],
    "wa": ["Categoreye"],
    "war": ["Kaarangay"],
    "wo": ["Wàll", "Catégorie"],
    "wuu": ["分类"],
    "xal": ["Янз", "Әәшл"],
    "xmf": ["კატეგორია"],
    "yi": ["קאטעגאריע", "קאַטעגאָריע"],
    "yo": ["Ẹ̀ka"],
    "za": ["分类"],
    "zea": ["Categorie"],
    "zh": ["分类", "分類", "CAT"],
    "zh-classical": ["分類", "CAT"],
    "zh-min-nan": ["分類", "Lūi-pia̍t"],
    "zh-yue": ["分类", "分類", "类", "類"],
}

# These values have been reproduced from article quality model and
# were adapted for use here by Diego Saez Trumper.
# See: https://gitlab.wikimedia.org/repos/research/knowledge_integrity/-/blob/309920e8ce16622ec46ee6eade8da74235c4a5c4/RRR/constants_article_quality_fill_min.csv  # noqa: E501
DEFAULT_FEATURE_VALS = {
    "length": 100.0,
    "media": 2.0,
    "categories": 5.0,
    "references": 0.15,
    "headings": 0.1,
    "wikilinks": 0.1,
}

MAX_FEATURE_VALS: Dict[str, Dict[str, float]] = {
    "aa": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "ab": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.898,
        "wikilinks": 0.124,
    },
    "ace": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1114,
    },
    "ady": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1702,
        "wikilinks": 0.1429,
    },
    "af": {
        "length": 107.589,
        "media": 4.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1271,
        "wikilinks": 0.1285,
    },
    "ak": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.2427,
        "headings": 0.1359,
        "wikilinks": 0.1,
    },
    "als": {
        "length": 111.594,
        "media": 4.0,
        "categories": 7.0,
        "references": 0.15,
        "headings": 0.1708,
        "wikilinks": 0.1261,
    },
    "alt": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "am": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1254,
        "wikilinks": 0.189,
    },
    "ami": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "an": {
        "length": 100.0,
        "media": 5.0,
        "categories": 7.0,
        "references": 0.15,
        "headings": 0.133,
        "wikilinks": 0.1658,
    },
    "ang": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1468,
    },
    "anp": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "ar": {
        "length": 104.967,
        "media": 2.0,
        "categories": 19.0,
        "references": 0.1571,
        "headings": 0.1076,
        "wikilinks": 0.1132,
    },
    "arc": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1873,
    },
    "ary": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1796,
        "wikilinks": 0.1377,
    },
    "arz": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2555,
        "wikilinks": 0.141,
    },
    "as": {
        "length": 127.02,
        "media": 4.0,
        "categories": 5.0,
        "references": 0.27,
        "headings": 0.1535,
        "wikilinks": 0.1061,
    },
    "ast": {
        "length": 156.731,
        "media": 6.0,
        "categories": 8.0,
        "references": 0.1707,
        "headings": 0.1372,
        "wikilinks": 0.1364,
    },
    "atj": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1482,
        "wikilinks": 0.1164,
    },
    "av": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2844,
        "wikilinks": 0.133,
    },
    "avk": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.3852,
        "wikilinks": 0.1525,
    },
    "awa": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1633,
    },
    "ay": {
        "length": 100.0,
        "media": 8.0,
        "categories": 7.0,
        "references": 0.15,
        "headings": 0.3277,
        "wikilinks": 0.1302,
    },
    "az": {
        "length": 103.189,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1397,
        "wikilinks": 0.1251,
    },
    "azb": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1231,
        "wikilinks": 0.1275,
    },
    "ba": {
        "length": 115.554,
        "media": 3.0,
        "categories": 10.0,
        "references": 0.15,
        "headings": 0.123,
        "wikilinks": 0.1,
    },
    "ban": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.1599,
        "headings": 0.2716,
        "wikilinks": 0.1206,
    },
    "bar": {
        "length": 101.98,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.127,
        "wikilinks": 0.1664,
    },
    "bat-smg": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1038,
        "wikilinks": 0.1518,
    },
    "bcl": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.7372,
        "wikilinks": 0.1806,
    },
    "be": {
        "length": 100.817,
        "media": 2.0,
        "categories": 7.0,
        "references": 0.15,
        "headings": 0.1079,
        "wikilinks": 0.1312,
    },
    "be-tarask": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "be-x-old": {
        "length": 100.003,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1529,
        "wikilinks": 0.1498,
    },
    "bg": {
        "length": 108.6,
        "media": 3.0,
        "categories": 7.0,
        "references": 0.15,
        "headings": 0.1191,
        "wikilinks": 0.1351,
    },
    "bh": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2741,
        "wikilinks": 0.12,
    },
    "bi": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1334,
    },
    "bjn": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1124,
        "wikilinks": 0.1622,
    },
    "blk": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "bm": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1006,
        "wikilinks": 0.1369,
    },
    "bn": {
        "length": 133.604,
        "media": 3.0,
        "categories": 12.0,
        "references": 0.2274,
        "headings": 0.185,
        "wikilinks": 0.1081,
    },
    "bo": {
        "length": 101.478,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.375,
        "wikilinks": 0.1,
    },
    "bpy": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.7016,
        "wikilinks": 0.1,
    },
    "br": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2228,
        "wikilinks": 0.1609,
    },
    "bs": {
        "length": 130.736,
        "media": 3.0,
        "categories": 7.0,
        "references": 0.2781,
        "headings": 0.1293,
        "wikilinks": 0.1558,
    },
    "bug": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1482,
    },
    "bxr": {
        "length": 103.055,
        "media": 5.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2179,
        "wikilinks": 0.1336,
    },
    "ca": {
        "length": 120.196,
        "media": 9.0,
        "categories": 7.0,
        "references": 0.1818,
        "headings": 0.1135,
        "wikilinks": 0.1344,
    },
    "cbk-zam": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1595,
        "wikilinks": 0.1443,
    },
    "cdo": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.3162,
        "wikilinks": 0.1703,
    },
    "ce": {
        "length": 100.0,
        "media": 2.0,
        "categories": 6.0,
        "references": 0.15,
        "headings": 0.1224,
        "wikilinks": 0.1,
    },
    "ceb": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.2225,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "ch": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1255,
    },
    "cho": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "chr": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.119,
        "wikilinks": 0.1265,
    },
    "chy": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1191,
    },
    "ckb": {
        "length": 100.0,
        "media": 2.0,
        "categories": 7.0,
        "references": 0.15,
        "headings": 0.1505,
        "wikilinks": 0.123,
    },
    "co": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.3239,
        "wikilinks": 0.1441,
    },
    "cr": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1754,
    },
    "crh": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2466,
        "wikilinks": 0.1078,
    },
    "cs": {
        "length": 130.911,
        "media": 4.0,
        "categories": 13.0,
        "references": 0.1849,
        "headings": 0.1351,
        "wikilinks": 0.1385,
    },
    "csb": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2236,
        "wikilinks": 0.1423,
    },
    "cu": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1303,
    },
    "cv": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1941,
        "wikilinks": 0.1384,
    },
    "cy": {
        "length": 100.0,
        "media": 9.0,
        "categories": 6.0,
        "references": 0.15,
        "headings": 0.114,
        "wikilinks": 0.1398,
    },
    "da": {
        "length": 107.434,
        "media": 3.0,
        "categories": 7.0,
        "references": 0.15,
        "headings": 0.1099,
        "wikilinks": 0.1429,
    },
    "dag": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "de": {
        "length": 137.474,
        "media": 4.0,
        "categories": 11.0,
        "references": 0.1927,
        "headings": 0.1193,
        "wikilinks": 0.1194,
    },
    "din": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "diq": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.213,
        "wikilinks": 0.1434,
    },
    "dsb": {
        "length": 100.0,
        "media": 3.0,
        "categories": 6.0,
        "references": 0.15,
        "headings": 0.1809,
        "wikilinks": 0.1533,
    },
    "dty": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1615,
        "wikilinks": 0.1112,
    },
    "dv": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2099,
        "wikilinks": 0.1102,
    },
    "dz": {
        "length": 100.0,
        "media": 4.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.4685,
        "wikilinks": 0.1328,
    },
    "ee": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1288,
    },
    "el": {
        "length": 145.116,
        "media": 4.0,
        "categories": 7.0,
        "references": 0.2171,
        "headings": 0.1159,
        "wikilinks": 0.1196,
    },
    "eml": {
        "length": 100.0,
        "media": 4.0,
        "categories": 6.0,
        "references": 0.15,
        "headings": 0.2268,
        "wikilinks": 0.1418,
    },
    "en": {
        "length": 165.655,
        "media": 3.0,
        "categories": 14.0,
        "references": 0.2944,
        "headings": 0.1152,
        "wikilinks": 0.1158,
    },
    "eo": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.132,
        "wikilinks": 0.1529,
    },
    "es": {
        "length": 144.903,
        "media": 4.0,
        "categories": 9.0,
        "references": 0.1933,
        "headings": 0.1186,
        "wikilinks": 0.1264,
    },
    "et": {
        "length": 100.0,
        "media": 3.0,
        "categories": 6.0,
        "references": 0.1737,
        "headings": 0.1299,
        "wikilinks": 0.154,
    },
    "eu": {
        "length": 100.0,
        "media": 10.0,
        "categories": 6.0,
        "references": 0.15,
        "headings": 0.1532,
        "wikilinks": 0.1296,
    },
    "ext": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1207,
        "wikilinks": 0.1363,
    },
    "fa": {
        "length": 100.0,
        "media": 2.0,
        "categories": 18.0,
        "references": 0.15,
        "headings": 0.1022,
        "wikilinks": 0.116,
    },
    "fat": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "ff": {
        "length": 100.0,
        "media": 4.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.124,
    },
    "fi": {
        "length": 113.195,
        "media": 2.0,
        "categories": 6.0,
        "references": 0.2525,
        "headings": 0.11,
        "wikilinks": 0.1254,
    },
    "fiu-vro": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.4407,
        "wikilinks": 0.1693,
    },
    "fj": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1615,
    },
    "fo": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2572,
        "wikilinks": 0.2192,
    },
    "fr": {
        "length": 153.007,
        "media": 3.0,
        "categories": 11.0,
        "references": 0.2586,
        "headings": 0.1577,
        "wikilinks": 0.1301,
    },
    "frp": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.158,
        "headings": 0.2804,
        "wikilinks": 0.1624,
    },
    "frr": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1275,
        "wikilinks": 0.1629,
    },
    "fur": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.4969,
        "wikilinks": 0.1593,
    },
    "fy": {
        "length": 105.995,
        "media": 6.0,
        "categories": 13.0,
        "references": 0.15,
        "headings": 0.1438,
        "wikilinks": 0.1493,
    },
    "ga": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1944,
        "wikilinks": 0.147,
    },
    "gag": {
        "length": 100.0,
        "media": 9.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.4811,
        "wikilinks": 0.1481,
    },
    "gan": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.6338,
        "wikilinks": 0.2093,
    },
    "gcr": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.4131,
        "wikilinks": 0.1,
    },
    "gd": {
        "length": 100.0,
        "media": 4.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2402,
        "wikilinks": 0.1622,
    },
    "gl": {
        "length": 125.972,
        "media": 4.0,
        "categories": 8.0,
        "references": 0.1696,
        "headings": 0.1572,
        "wikilinks": 0.1418,
    },
    "glk": {
        "length": 100.0,
        "media": 2.0,
        "categories": 6.0,
        "references": 0.15,
        "headings": 0.2448,
        "wikilinks": 0.1523,
    },
    "gn": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2688,
        "wikilinks": 0.1468,
    },
    "gom": {
        "length": 102.165,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1652,
        "wikilinks": 0.1,
    },
    "gor": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1032,
    },
    "got": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1384,
    },
    "gpe": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "gsw": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "gu": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.111,
        "wikilinks": 0.1499,
    },
    "guc": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "gur": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "guw": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "gv": {
        "length": 100.0,
        "media": 2.0,
        "categories": 7.0,
        "references": 0.15,
        "headings": 0.3244,
        "wikilinks": 0.1642,
    },
    "ha": {
        "length": 109.607,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.1797,
        "headings": 0.1394,
        "wikilinks": 0.1216,
    },
    "hak": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.5538,
        "wikilinks": 0.1559,
    },
    "haw": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1628,
    },
    "he": {
        "length": 127.098,
        "media": 5.0,
        "categories": 12.0,
        "references": 0.15,
        "headings": 0.1286,
        "wikilinks": 0.156,
    },
    "hi": {
        "length": 107.984,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1911,
        "wikilinks": 0.1267,
    },
    "hif": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1364,
        "wikilinks": 0.1259,
    },
    "ho": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "hr": {
        "length": 113.159,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1249,
        "wikilinks": 0.1445,
    },
    "hsb": {
        "length": 100.0,
        "media": 2.0,
        "categories": 8.0,
        "references": 0.15,
        "headings": 0.1785,
        "wikilinks": 0.141,
    },
    "ht": {
        "length": 100.0,
        "media": 2.0,
        "categories": 7.0,
        "references": 0.15,
        "headings": 0.3254,
        "wikilinks": 0.1732,
    },
    "hu": {
        "length": 136.629,
        "media": 3.0,
        "categories": 8.0,
        "references": 0.2167,
        "headings": 0.1593,
        "wikilinks": 0.1261,
    },
    "hy": {
        "length": 122.958,
        "media": 2.0,
        "categories": 8.0,
        "references": 0.1842,
        "headings": 0.1187,
        "wikilinks": 0.1298,
    },
    "hyw": {
        "length": 126.298,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.1713,
        "headings": 0.1523,
        "wikilinks": 0.1312,
    },
    "hz": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "ia": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1859,
        "wikilinks": 0.1476,
    },
    "id": {
        "length": 111.113,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.1602,
        "headings": 0.1046,
        "wikilinks": 0.1354,
    },
    "ie": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1153,
        "wikilinks": 0.1591,
    },
    "ig": {
        "length": 106.387,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.2395,
        "headings": 0.168,
        "wikilinks": 0.125,
    },
    "ii": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "ik": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1216,
    },
    "ilo": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.113,
        "wikilinks": 0.1286,
    },
    "inh": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1387,
        "wikilinks": 0.1334,
    },
    "io": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1677,
        "wikilinks": 0.1637,
    },
    "is": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1066,
        "wikilinks": 0.1599,
    },
    "it": {
        "length": 142.014,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.1791,
        "headings": 0.1468,
        "wikilinks": 0.1355,
    },
    "iu": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1459,
    },
    "ja": {
        "length": 127.475,
        "media": 3.0,
        "categories": 11.0,
        "references": 0.3435,
        "headings": 0.214,
        "wikilinks": 0.1886,
    },
    "jam": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.123,
    },
    "jbo": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2723,
        "wikilinks": 0.1574,
    },
    "jv": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.1827,
        "headings": 0.1404,
        "wikilinks": 0.1336,
    },
    "ka": {
        "length": 100.169,
        "media": 2.0,
        "categories": 7.0,
        "references": 0.15,
        "headings": 0.1059,
        "wikilinks": 0.1266,
    },
    "kaa": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1562,
        "wikilinks": 0.1452,
    },
    "kab": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1871,
        "wikilinks": 0.1579,
    },
    "kbd": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1122,
        "wikilinks": 0.1312,
    },
    "kbp": {
        "length": 100.0,
        "media": 4.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.5193,
        "wikilinks": 0.1,
    },
    "kcg": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "kg": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1637,
    },
    "ki": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1272,
    },
    "kj": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "kk": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1128,
    },
    "kl": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1729,
        "wikilinks": 0.1359,
    },
    "km": {
        "length": 133.758,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1733,
        "wikilinks": 0.1696,
    },
    "kn": {
        "length": 174.293,
        "media": 5.0,
        "categories": 6.0,
        "references": 0.1874,
        "headings": 0.1991,
        "wikilinks": 0.1318,
    },
    "ko": {
        "length": 100.0,
        "media": 2.0,
        "categories": 14.0,
        "references": 0.1534,
        "headings": 0.179,
        "wikilinks": 0.1815,
    },
    "koi": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.3573,
        "wikilinks": 0.1501,
    },
    "kr": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "krc": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.25,
        "wikilinks": 0.1411,
    },
    "ks": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1404,
    },
    "ksh": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.198,
        "wikilinks": 0.1546,
    },
    "ku": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1321,
        "wikilinks": 0.1497,
    },
    "kv": {
        "length": 100.0,
        "media": 3.0,
        "categories": 6.0,
        "references": 0.15,
        "headings": 0.2536,
        "wikilinks": 0.1537,
    },
    "kw": {
        "length": 100.0,
        "media": 4.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1485,
    },
    "ky": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "la": {
        "length": 100.0,
        "media": 2.0,
        "categories": 7.0,
        "references": 0.15,
        "headings": 0.1615,
        "wikilinks": 0.144,
    },
    "lad": {
        "length": 100.0,
        "media": 7.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1431,
        "wikilinks": 0.1329,
    },
    "lb": {
        "length": 100.0,
        "media": 2.0,
        "categories": 6.0,
        "references": 0.15,
        "headings": 0.2083,
        "wikilinks": 0.1555,
    },
    "lbe": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1534,
    },
    "lez": {
        "length": 105.482,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1375,
        "wikilinks": 0.129,
    },
    "lfn": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1368,
    },
    "lg": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1423,
    },
    "li": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1151,
        "wikilinks": 0.1665,
    },
    "lij": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.5707,
        "wikilinks": 0.1253,
    },
    "lld": {
        "length": 100.0,
        "media": 4.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1406,
        "wikilinks": 0.1736,
    },
    "lmo": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1433,
        "wikilinks": 0.1395,
    },
    "ln": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2691,
        "wikilinks": 0.165,
    },
    "lo": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1686,
        "wikilinks": 0.1491,
    },
    "lrc": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "lt": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.2524,
        "headings": 0.1182,
        "wikilinks": 0.1375,
    },
    "ltg": {
        "length": 100.0,
        "media": 4.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1511,
        "wikilinks": 0.132,
    },
    "lv": {
        "length": 106.701,
        "media": 3.0,
        "categories": 8.0,
        "references": 0.15,
        "headings": 0.1054,
        "wikilinks": 0.1326,
    },
    "lzh": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "mad": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "mai": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.6803,
        "wikilinks": 0.1057,
    },
    "map-bms": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1762,
        "wikilinks": 0.1387,
    },
    "mdf": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1662,
        "wikilinks": 0.14,
    },
    "mg": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1504,
        "wikilinks": 0.127,
    },
    "mh": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "mhr": {
        "length": 100.0,
        "media": 6.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2474,
        "wikilinks": 0.1681,
    },
    "mi": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.536,
        "wikilinks": 0.1375,
    },
    "min": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1284,
    },
    "mk": {
        "length": 127.802,
        "media": 4.0,
        "categories": 7.0,
        "references": 0.1647,
        "headings": 0.168,
        "wikilinks": 0.1252,
    },
    "ml": {
        "length": 114.348,
        "media": 3.0,
        "categories": 7.0,
        "references": 0.1801,
        "headings": 0.1257,
        "wikilinks": 0.1166,
    },
    "mn": {
        "length": 109.937,
        "media": 3.0,
        "categories": 12.0,
        "references": 0.15,
        "headings": 0.124,
        "wikilinks": 0.1299,
    },
    "mni": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "mnw": {
        "length": 170.186,
        "media": 4.0,
        "categories": 5.0,
        "references": 0.2036,
        "headings": 0.1792,
        "wikilinks": 0.1062,
    },
    "mr": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1969,
        "wikilinks": 0.1361,
    },
    "mrj": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.169,
    },
    "ms": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1093,
        "wikilinks": 0.1407,
    },
    "mt": {
        "length": 162.585,
        "media": 7.0,
        "categories": 8.0,
        "references": 0.1896,
        "headings": 0.1184,
        "wikilinks": 0.1381,
    },
    "mus": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "mwl": {
        "length": 166.053,
        "media": 8.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1152,
        "wikilinks": 0.1328,
    },
    "my": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1137,
        "wikilinks": 0.1,
    },
    "myv": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1945,
        "wikilinks": 0.1332,
    },
    "mzn": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2206,
        "wikilinks": 0.1257,
    },
    "na": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.2315,
    },
    "nah": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.213,
        "wikilinks": 0.1541,
    },
    "nan": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "nap": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2206,
        "wikilinks": 0.1359,
    },
    "nds": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1343,
        "wikilinks": 0.1356,
    },
    "nds-nl": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.3254,
        "wikilinks": 0.1627,
    },
    "ne": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2046,
        "wikilinks": 0.1201,
    },
    "new": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.296,
        "wikilinks": 0.1437,
    },
    "ng": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "nia": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "nl": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1272,
    },
    "nn": {
        "length": 100.0,
        "media": 2.0,
        "categories": 8.0,
        "references": 0.15,
        "headings": 0.1074,
        "wikilinks": 0.1357,
    },
    "no": {
        "length": 100.832,
        "media": 3.0,
        "categories": 8.0,
        "references": 0.15,
        "headings": 0.1243,
        "wikilinks": 0.1373,
    },
    "nostalgia": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.2182,
    },
    "nov": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1882,
        "wikilinks": 0.1754,
    },
    "nqo": {
        "length": 104.758,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1634,
        "wikilinks": 0.1741,
    },
    "nrm": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2412,
        "wikilinks": 0.165,
    },
    "nso": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1692,
    },
    "nv": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "ny": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.1548,
        "headings": 0.1049,
        "wikilinks": 0.1543,
    },
    "oc": {
        "length": 100.0,
        "media": 14.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2095,
        "wikilinks": 0.1459,
    },
    "olo": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1982,
        "wikilinks": 0.1282,
    },
    "om": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1301,
    },
    "or": {
        "length": 100.0,
        "media": 2.0,
        "categories": 6.0,
        "references": 0.3116,
        "headings": 0.7146,
        "wikilinks": 0.1011,
    },
    "os": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.3062,
        "wikilinks": 0.1388,
    },
    "pa": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.173,
        "headings": 0.1362,
        "wikilinks": 0.1251,
    },
    "pag": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1926,
        "wikilinks": 0.1158,
    },
    "pam": {
        "length": 100.0,
        "media": 2.0,
        "categories": 9.0,
        "references": 0.15,
        "headings": 0.1489,
        "wikilinks": 0.1362,
    },
    "pap": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.114,
        "wikilinks": 0.1519,
    },
    "pcd": {
        "length": 100.0,
        "media": 6.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1275,
        "wikilinks": 0.1176,
    },
    "pcm": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "pdc": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1369,
    },
    "pfl": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1815,
        "wikilinks": 0.1,
    },
    "pi": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.3133,
        "wikilinks": 0.1108,
    },
    "pih": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1671,
    },
    "pl": {
        "length": 116.842,
        "media": 3.0,
        "categories": 10.0,
        "references": 0.1694,
        "headings": 0.1001,
        "wikilinks": 0.1297,
    },
    "pms": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.159,
        "wikilinks": 0.1255,
    },
    "pnb": {
        "length": 124.058,
        "media": 3.0,
        "categories": 12.0,
        "references": 0.1586,
        "headings": 0.2153,
        "wikilinks": 0.1373,
    },
    "pnt": {
        "length": 100.0,
        "media": 6.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1482,
    },
    "ps": {
        "length": 113.856,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2858,
        "wikilinks": 0.1325,
    },
    "pt": {
        "length": 137.717,
        "media": 5.0,
        "categories": 8.0,
        "references": 0.207,
        "headings": 0.1,
        "wikilinks": 0.1269,
    },
    "pwn": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "qu": {
        "length": 100.0,
        "media": 6.0,
        "categories": 7.0,
        "references": 0.15,
        "headings": 0.2378,
        "wikilinks": 0.1575,
    },
    "rm": {
        "length": 182.658,
        "media": 12.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1368,
        "wikilinks": 0.1267,
    },
    "rmy": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1389,
        "wikilinks": 0.1482,
    },
    "rn": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1715,
    },
    "ro": {
        "length": 112.656,
        "media": 2.0,
        "categories": 7.0,
        "references": 0.2354,
        "headings": 0.1148,
        "wikilinks": 0.1293,
    },
    "roa-rup": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2822,
        "wikilinks": 0.1622,
    },
    "roa-tara": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1213,
    },
    "ru": {
        "length": 142.674,
        "media": 3.0,
        "categories": 9.0,
        "references": 0.2115,
        "headings": 0.1148,
        "wikilinks": 0.1163,
    },
    "rue": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.417,
        "wikilinks": 0.1495,
    },
    "rup": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "rw": {
        "length": 100.0,
        "media": 5.0,
        "categories": 5.0,
        "references": 0.2061,
        "headings": 0.1062,
        "wikilinks": 0.1201,
    },
    "sa": {
        "length": 101.801,
        "media": 2.0,
        "categories": 7.0,
        "references": 0.15,
        "headings": 0.6746,
        "wikilinks": 0.1132,
    },
    "sah": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2402,
        "wikilinks": 0.138,
    },
    "sat": {
        "length": 101.754,
        "media": 3.0,
        "categories": 8.0,
        "references": 0.1636,
        "headings": 0.1574,
        "wikilinks": 0.1558,
    },
    "sc": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.14,
    },
    "scn": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1287,
        "wikilinks": 0.1764,
    },
    "sco": {
        "length": 100.0,
        "media": 2.0,
        "categories": 24.0,
        "references": 0.15,
        "headings": 0.1003,
        "wikilinks": 0.1304,
    },
    "sd": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.8127,
        "wikilinks": 0.123,
    },
    "se": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2942,
        "wikilinks": 0.1393,
    },
    "sg": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "sgs": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "sh": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1367,
    },
    "shi": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "shn": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 1.0769,
        "wikilinks": 0.1028,
    },
    "si": {
        "length": 122.514,
        "media": 3.0,
        "categories": 6.0,
        "references": 0.15,
        "headings": 0.1269,
        "wikilinks": 0.1228,
    },
    "simple": {
        "length": 100.0,
        "media": 2.0,
        "categories": 9.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1426,
    },
    "sk": {
        "length": 118.507,
        "media": 2.0,
        "categories": 6.0,
        "references": 0.15,
        "headings": 0.1224,
        "wikilinks": 0.1398,
    },
    "skr": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "sl": {
        "length": 123.527,
        "media": 4.0,
        "categories": 9.0,
        "references": 0.15,
        "headings": 0.1386,
        "wikilinks": 0.1538,
    },
    "sm": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.4127,
        "wikilinks": 0.1543,
    },
    "smn": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "sn": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1515,
    },
    "so": {
        "length": 100.0,
        "media": 4.0,
        "categories": 8.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1457,
    },
    "sq": {
        "length": 104.346,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2183,
        "wikilinks": 0.1313,
    },
    "sr": {
        "length": 180.233,
        "media": 2.0,
        "categories": 6.0,
        "references": 0.15,
        "headings": 0.1098,
        "wikilinks": 0.1132,
    },
    "srn": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2146,
        "wikilinks": 0.1352,
    },
    "ss": {
        "length": 100.0,
        "media": 4.0,
        "categories": 5.0,
        "references": 0.1645,
        "headings": 0.1359,
        "wikilinks": 0.1452,
    },
    "st": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1571,
    },
    "stq": {
        "length": 100.0,
        "media": 4.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1132,
        "wikilinks": 0.1555,
    },
    "su": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.408,
        "wikilinks": 0.1162,
    },
    "sv": {
        "length": 100.0,
        "media": 2.0,
        "categories": 7.0,
        "references": 0.2256,
        "headings": 0.1,
        "wikilinks": 0.1193,
    },
    "sw": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2171,
        "wikilinks": 0.1613,
    },
    "szl": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.1832,
        "headings": 0.1,
        "wikilinks": 0.1167,
    },
    "szy": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1857,
        "wikilinks": 0.1121,
    },
    "ta": {
        "length": 102.811,
        "media": 2.0,
        "categories": 7.0,
        "references": 0.1559,
        "headings": 0.1222,
        "wikilinks": 0.1138,
    },
    "tay": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "tcy": {
        "length": 100.0,
        "media": 4.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2031,
        "wikilinks": 0.1135,
    },
    "te": {
        "length": 106.321,
        "media": 2.0,
        "categories": 6.0,
        "references": 0.15,
        "headings": 0.2155,
        "wikilinks": 0.128,
    },
    "test": {
        "length": 177.534,
        "media": 2.0,
        "categories": 7.0,
        "references": 0.1806,
        "headings": 0.2593,
        "wikilinks": 0.1231,
    },
    "test2": {
        "length": 101.538,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.19,
        "headings": 0.2572,
        "wikilinks": 0.1938,
    },
    "tet": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2942,
        "wikilinks": 0.1419,
    },
    "tg": {
        "length": 100.0,
        "media": 2.0,
        "categories": 13.0,
        "references": 0.15,
        "headings": 0.2074,
        "wikilinks": 0.1008,
    },
    "th": {
        "length": 140.717,
        "media": 4.0,
        "categories": 9.0,
        "references": 0.1992,
        "headings": 0.1412,
        "wikilinks": 0.1299,
    },
    "ti": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1525,
    },
    "tk": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.3518,
        "wikilinks": 0.1208,
    },
    "tl": {
        "length": 109.685,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1068,
        "wikilinks": 0.133,
    },
    "tly": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "tn": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1068,
        "wikilinks": 0.1728,
    },
    "to": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.126,
    },
    "tpi": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1608,
    },
    "tr": {
        "length": 122.045,
        "media": 2.0,
        "categories": 13.0,
        "references": 0.265,
        "headings": 0.1065,
        "wikilinks": 0.1221,
    },
    "trv": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "ts": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.1576,
        "headings": 0.2041,
        "wikilinks": 0.1291,
    },
    "tt": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1467,
        "wikilinks": 0.1,
    },
    "tum": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1072,
    },
    "tw": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.1606,
        "headings": 0.1077,
        "wikilinks": 0.1104,
    },
    "ty": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2727,
        "wikilinks": 0.1174,
    },
    "tyv": {
        "length": 102.922,
        "media": 3.0,
        "categories": 5.2,
        "references": 0.15,
        "headings": 0.1251,
        "wikilinks": 0.1294,
    },
    "udm": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1156,
        "wikilinks": 0.1518,
    },
    "ug": {
        "length": 113.552,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2992,
        "wikilinks": 0.1174,
    },
    "uk": {
        "length": 118.583,
        "media": 3.0,
        "categories": 9.0,
        "references": 0.15,
        "headings": 0.1151,
        "wikilinks": 0.1302,
    },
    "ur": {
        "length": 100.0,
        "media": 2.0,
        "categories": 12.0,
        "references": 0.15,
        "headings": 0.1434,
        "wikilinks": 0.1219,
    },
    "uz": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1145,
        "wikilinks": 0.1104,
    },
    "ve": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1463,
    },
    "vec": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.141,
        "wikilinks": 0.1064,
    },
    "vep": {
        "length": 100.0,
        "media": 2.0,
        "categories": 7.0,
        "references": 0.15,
        "headings": 0.1229,
        "wikilinks": 0.1297,
    },
    "vi": {
        "length": 100.0,
        "media": 2.0,
        "categories": 6.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1168,
    },
    "vls": {
        "length": 100.0,
        "media": 6.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1244,
        "wikilinks": 0.1637,
    },
    "vo": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1446,
    },
    "vro": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "wa": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2315,
        "wikilinks": 0.1875,
    },
    "war": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.2619,
        "headings": 0.1,
        "wikilinks": 0.1313,
    },
    "wo": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1498,
        "wikilinks": 0.1447,
    },
    "wuu": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1571,
        "wikilinks": 0.2159,
    },
    "xal": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2709,
        "wikilinks": 0.1414,
    },
    "xh": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1355,
    },
    "xmf": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2449,
        "wikilinks": 0.1348,
    },
    "yi": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1462,
        "wikilinks": 0.1773,
    },
    "yo": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.3094,
        "wikilinks": 0.1231,
    },
    "yue": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1,
    },
    "za": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.4193,
        "wikilinks": 0.169,
    },
    "zea": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1491,
    },
    "zh": {
        "length": 111.92,
        "media": 3.0,
        "categories": 9.0,
        "references": 0.246,
        "headings": 0.1599,
        "wikilinks": 0.1794,
    },
    "zh-classical": {
        "length": 100.0,
        "media": 3.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.214,
        "wikilinks": 0.2535,
    },
    "zh-min-nan": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1158,
        "wikilinks": 0.1291,
    },
    "zh-yue": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.2741,
        "wikilinks": 0.2284,
    },
    "zu": {
        "length": 100.0,
        "media": 2.0,
        "categories": 5.0,
        "references": 0.15,
        "headings": 0.1,
        "wikilinks": 0.1072,
    },
}
